package hmggirlfront.render.mob;

import org.lwjgl.opengl.GL11;
import org.lwjgl.opengl.GL12;

import gvclib.render.ModelBase_Non;
import hmggirlfront.entity.mob.EntityIBC03;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.renderer.OpenGlHelper;
import net.minecraft.client.renderer.entity.Render;
import net.minecraft.client.renderer.entity.RenderLiving;
import net.minecraft.client.renderer.entity.RenderManager;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.math.MathHelper;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import objmodel.AdvancedModelLoader;
import objmodel.IModelCustom;

@SideOnly(Side.CLIENT)
public class RenderIBC03 extends RenderLiving<EntityIBC03>
{
    private static final ResourceLocation boatTextures = new ResourceLocation("hmggirlfront:textures/model/mob/ibc03.png");
    private static final IModelCustom tankk = AdvancedModelLoader.loadModel(new ResourceLocation("hmggirlfront:textures/model/mob/ibc03.mqo"));
    /** instance of ModelBoat for rendering */

    public RenderIBC03(RenderManager renderManagerIn)
    {
    	super(renderManagerIn, new ModelBase_Non(),0.5F);
        this.shadowSize = 0.5F;
    }

    /**
     * Actually renders the given argument. This is a synthetic bridge method, always casting down its argument and then
     * handing it off to a worker function which does the actual work. In all probabilty, the class Render is generic
     * (Render<T extends Entity>) and this method has signature public void func_76986_a(T entity, double d, double d1,
     * double d2, float f, float f1). But JAD is pre 1.5 so doe
     */
    float iii;
    public void doRender(EntityIBC03 entity, double x, double y, double z, float entityYaw, float partialTicks)
    {
        this.bindEntityTexture(entity);
        float limbSwing = this.F6(entity, partialTicks);
		float limbSwingAmount = this.F5(entity, partialTicks);
		
        GL11.glPushMatrix();//glstart
		GL11.glTranslatef((float) x, (float) y, (float) z);
		GL11.glRotatef(180F, 0.0F, 1.0F, 0.0F);
		GL11.glEnable(GL12.GL_RESCALE_NORMAL);
		float f = this.interpolateRotation(entity.prevRenderYawOffset, entity.renderYawOffset, partialTicks);
		float f8 = this.handleRotationFloat(entity, partialTicks);
		this.applyRotations(entity, f8, f, partialTicks);
		
		if(entity.deathTime > 0){
			GL11.glColor4f(0.7F, 0.2F, 0.2F, 1F);
		}else {
			if(entity.hurtTime > 0) {
				GL11.glColor4f(0.7F, 0.2F, 0.2F, 1F);
			}else {
				GL11.glColor4f(1F, 1F, 1F, 1F);
			}
		}
		{
	    	GL11.glTranslatef(0, 0, 0);
	    	float Ax = MathHelper.cos(limbSwing * 0.6662F + (float)Math.PI) * limbSwingAmount;
	    	GL11.glRotatef(Ax * (180F / (float)Math.PI) * 0.25F, 1.0F, 0.0F, 0.0F);
			GL11.glTranslatef(-0, -0, -0);
			GL11.glTranslatef(0, Math.abs(Ax * (180F / (float)Math.PI) * 0.01F), 0);
		}
			tankk.renderPart("body");
			{
				GL11.glPushMatrix();//glstart
				int i = 15728880;
		        int j = i % 65536;
		        int k = i / 65536;
		        OpenGlHelper.setLightmapTextureCoords(OpenGlHelper.lightmapTexUnit, (float)j, (float)k);
				tankk.renderPart("body_light");
				GL11.glPopMatrix();//glend
			}
			renderleg(entity, 0.225F, 0.3F, 0.225F, "leg_l1", partialTicks, 1F);
			renderleg(entity, -0.225F, 0.3F, 0.225F, "leg_r1", partialTicks, 1F);
			renderleg(entity, 0.225F, 0.35F, -0.25F, "leg_l2", partialTicks, -1F);
			renderleg(entity, -0.225F, 0.35F, -0.25F, "leg_r2", partialTicks,-1F);
			GL11.glRotatef(-(180.0F - entityYaw), 0.0F, 1.0F, 0.0F);
		
		{
			
			GL11.glPushMatrix();//glstart
			GL11.glTranslatef(0F, 0.7F, 0F);
			GL11.glRotatef(180.0F - entity.rotation, 0.0F, 1.0F, 0.0F);
			GL11.glTranslatef(0F, -0.7F, 0F);
			tankk.renderPart("head");
			GL11.glPopMatrix();//glend
		}
		GL11.glColor4f(1F, 1F, 1F, 1F);
		GL11.glDisable(GL12.GL_RESCALE_NORMAL);
		GL11.glPopMatrix();//glend
        super.doRender(entity, x, y, z, entityYaw, partialTicks);
    }
    
    public void renderleg(EntityLivingBase entity, float x, float y, float z, String name, float partialTicks, float ho){
    	float limbSwing = this.F6(entity, partialTicks);
		float limbSwingAmount = this.F5(entity, partialTicks);
    	GL11.glPushMatrix();
    	GL11.glTranslatef(x, y, z);
    	float Ax = MathHelper.cos(limbSwing * 0.6662F + (float)Math.PI) * limbSwingAmount;
    	GL11.glRotatef(Ax * (180F / (float)Math.PI) * 1, ho, 0.0F, 0.0F);
		GL11.glTranslatef(-x, -y, -z);
		tankk.renderPart(name);
		GL11.glPopMatrix();
    }
    
    public float F6(EntityLivingBase entity, float partialTicks){
 		float f6 = 0;
 		if (!entity.isRiding())
        {
            f6 = entity.limbSwing - entity.limbSwingAmount * (1.0F - partialTicks);
            if (entity.isChild())
            {
                f6 *= 3.0F;
            }
        }
 		return f6;
 	}
 	public float F5(EntityLivingBase entity, float partialTicks){
 		float f5 = 0;
 		if (!entity.isRiding())
        {
            f5 = entity.prevLimbSwingAmount + (entity.limbSwingAmount - entity.prevLimbSwingAmount) * partialTicks;
            if (f5 > 1.0F)
            {
                f5 = 1.0F;
            }
        }
 		return f5;
 	}
    
    /**
     * Returns the location of an entity's texture. Doesn't seem to be called unless you call Render.bindEntityTexture.
     */
    protected ResourceLocation getEntityTexture(EntityIBC03 entity)
    {
        return boatTextures;
    }
    
    protected void renderLivingAt(EntityIBC03 entityLivingBaseIn, double x, double y, double z)
    {
        GlStateManager.translate((float)x, (float)y, (float)z);
    }
    protected float handleRotationFloat(EntityIBC03 livingBase, float partialTicks)
    {
        return (float)livingBase.ticksExisted + partialTicks;
    }
}